## $Id: test_document.py 12259 2014-12-18 15:47:12Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
Tests for documents.
"""
import tempfile
import shutil
from zope.interface.verify import verifyClass, verifyObject
from zope.component import createObject
from zope.component.hooks import setSite
from zope.interface import verify
from waeup.ikoba.app import Company
from waeup.ikoba.customers.interfaces import ICustomerNavigation
from waeup.ikoba.customers.interfaces import (
    ICustomersContainer, ICustomerNavigation)
from waeup.ikoba.customers.documents import CustomerDocumentsContainer

from ikobacustom.skeleton.testing import (FunctionalLayer, FunctionalTestCase)
from ikobacustom.skeleton.customers.documents import SkeletonCustomerDocument
from ikobacustom.skeleton.customers.interfaces import ISkeletonCustomerDocument


class DocumentsContainerTestCase(FunctionalTestCase):

    layer = FunctionalLayer

    def test_interfaces(self):
        verify.verifyClass(ISkeletonCustomerDocument, SkeletonCustomerDocument)
        verify.verifyClass(ICustomerNavigation, SkeletonCustomerDocument)
        verify.verifyObject(ISkeletonCustomerDocument, SkeletonCustomerDocument())
        verify.verifyObject(ICustomerNavigation, SkeletonCustomerDocument())
        return

    def test_addDocument(self):
        container = CustomerDocumentsContainer()
        document = createObject(u'waeup.SkeletonCustomerDocument')
        id = document.document_id
        container.addDocument(document)
        self.assertEqual(container[id], document)
        self.assertRaises(TypeError, container.addDocument, object())
        self.assertEqual(document.class_name, 'SkeletonCustomerDocument')
        return
